#! /usr/bin/env python
                
#######################################################################
#                                                                     #
# rt.py v1.2 (c) Frank Kauff 2005                                     #
#                                                                     #
# picks trees out of treefile on random or regular base               #
#                                                                     #
#       Usage:                                                        # 
#       rt.py <filename> -s <step-value> [-b <burnin>]                #
#       rt.py <filename> -r <number of random trees> [-b <burnin>]    #
#                                                                     #
#                                                                     #
# Comments, bugs, suggestions to: fkauff@duke.edu                     #
#                                                                     #
# Distributed under GNU Public License                                #                                    #
#                                                                     #
#                                                                     #
#######################################################################


import sys
from optparse import OptionParser
from random import randint
       
parser=OptionParser('usage:\n%prog <treefile1> -s <step-value> [-b <burnin>]\n%prog <treefile1> -r <no. of random trees> [-b <burnin>]')
parser.add_option('-s','--step',dest='step',help='step: sample every n-th tree',default=0,type='int',metavar='<step>')
parser.add_option('-r','--random',dest='random',help='random: sample n random trees',default=0,type='int',metavar='<random>')
parser.add_option('-b','--burnin',dest='burnin',help='burnin: no. of tree to skip as \'burnin\'',default=0,type='int',metavar='<burnin>')
(options,args)=parser.parse_args(sys.argv[1:])

if (options.random<=0 and options.step<=0) or (options.random>0 and options.step>0):
    sys.exit('Please provide either step-value or no. of random trees to choose.')

treelines=[t.strip() for t in open(args[0],'rU').readlines() if t.strip().lower().startswith('tree')]

if options.step>0:
    picklist=range(options.burnin+options.step-1,len(treelines),options.step)
    #print 'collecting step:',len(picklist)
else:
    picklist=[]
    while len(picklist)!=options.random:
        rn=randint(options.burnin,len(treelines))
        if rn not in picklist:
            picklist.append(rn)
    picklist.sort()
    #print 'collecting random trees:',len(picklist)

print '\n'.join([t for i,t in enumerate(treelines) if i in picklist])

